
/* Copyright (C) 2001 John Price <linux-guru@gcfl.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */

#ifndef _SERIAL_H_
#define _SERIAL_H_

#include "serial_config.h"

#define CR 13   // Carriage Return
#define LF 10   // Line Feed
#define UART_TRANSMITTING   0x01
#define UART_RX_OVERFLOW    0x02
#define UART_CR_RECEIVED    0x04

void UART_RTSCTS_init(void);

extern char uart0_rx_buf[];
extern char uart0_tx_buf[];

extern unsigned char uart0_rx_head, uart0_rx_tail;
extern unsigned char uart0_tx_head, uart0_tx_tail;
extern unsigned char uart0_flags;

extern char uart1_rx_buf[];
extern char uart1_tx_buf[];

extern unsigned char uart1_rx_head, uart1_rx_tail;
extern unsigned char uart1_tx_head, uart1_tx_tail;
extern unsigned char uart1_flags;

#ifdef USE_UART0
    extern unsigned char uart0_flags;
    
    void UART0_init(void);

    unsigned char UART0_RXready(void);
    char UART0_getchar(void);
    char UART0_putchar(char c);
    void UART0_putstring(char *s);

    #ifdef UART0_INT_DRIVEN
        void UART0_ClearTxBuffer(void);
        void UART0_ClearRxBuffer(void);

        unsigned char UART0_TxBufferEmpty(void);
        unsigned char UART0_RxBufferEmpty(void);

        unsigned char UART0_TxBufferFull(void);
        unsigned char UART0_RxBufferFull(void);
    #endif
#endif							//USE_UART0


#ifdef USE_UART1
    extern unsigned char uart1_flags;

    void UART1_init(void);

    unsigned char UART1_RXready(void);
    char UART1_getchar(void);
    char UART1_putchar(char c);
    void UART1_putstring(char *s);
    void UART1_wait_tx_empty(void);
    
    #ifdef UART1_INT_DRIVEN
        void UART1_ClearTxBuffer(void);
        void UART1_ClearRxBuffer(void);

        void UART1_wait_tx_finished(void);

        unsigned char UART1_TxBufferEmpty(void);
        unsigned char UART1_RxBufferEmpty(void);

        unsigned char UART1_TxBufferFull(void);
        unsigned char UART1_RxBufferFull(void);
    #endif                      //UART1_INT_DRIVEN
#endif							//USE_UART1

#endif /* _SERIAL_H_ */
