#include "string.h"
#ifndef SMALL_SIZE
int strlen(char *string)
{
    int i = -1;
    if(string)
    {
        i++;
        while(*(string++))
        i++;
    }
    return(i);
}

char itoc(int i)
{
    if(i >= 0 && i <= 9)
        return('0' + i);

    return(0);
}

int ctoi(char c)
{
    if(c >= '0' && c <= '9')
    {
        return(c - '0');
    }

    return(-1);
}

int ten(int a)
{
    if(a == 0)
    {
        return(1);
    }

    return(10*ten(a-1));
}

int pow(int a, int b)
{
    if(b == 0)
    {
        return(1);
    }

    return(a*pow(a, b-1));
}

int atoi(char *string)
{
    int length = strlen(string);
    int i, j, value = 0;

    if(length == -1)
        return(-1);

    for(i = length-1; i >= 0; i--)
    {
        if(string[length - 1 - i] == ' ')
            continue;
        if( (j = ctoi(string[length - 1 - i])) == -1)
            return(-1);
        value += j*pow(10,i);
    }
    return(value);
}


char *itoa(unsigned int value)
{
    static char string[6]; // the max int is 65535
    unsigned int Ten, temp, notyet = 1;
    int i;

    for(i = 4; i >= 0; i--)
    {
        Ten = ten(i);
        temp = value / Ten;
        value -= temp*Ten;
        if(temp == 0 && (notyet && i != 0))
            string[4-i] = ' ';
        else
        {
            notyet = 0;
            string[4-i] = temp + '0';
        }
    }
    string[5] = '\0';

    return(string);
}
#endif

char *itoh(unsigned int value)
{
    static char buffer[5];
    char lut[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
    
    buffer[0] = lut[((value & 0xF000) >> 12)];
    buffer[1] = lut[((value & 0x0F00) >> 8)];
    buffer[2] = lut[((value & 0x00F0) >> 4)];
    buffer[3] = lut[ (value & 0x000F)];
    buffer[4] = '\0';
    return(buffer);
}
