/********************************************************************************************
 * FILE            : serial_config.h
 * AUTHOR:         : Emil Jovanov
 * DESCRIPTION     : Basic configuration of serial ports

 * REVISION HISTORY :
 * 02.10.04  E.J.   : First version
********************************************************************************************/
#ifndef _SERIAL_CONFIG_H_
#define _SERIAL_CONFIG_H_

//***** USART Configuration *****
#define USE_UART0  // uncomment this to compile in functions for UART0
// #define USE_UART1  // uncomment this to compile in functions for UART1

/* uncomment this to make UART interrupt driven */
#define UART0_INT_DRIVEN
// #define UART1_INT_DRIVEN

//*** RTS/CTS control
// #define UART0_USING_CTS_RTS
// #define UART1_USING_CTS_RTS

//***** UART0 *****
#ifdef UART0_INT_DRIVEN
#ifdef USE_UART0
	#define UART0_RX_BUFSIZE  64
	#define UART0_TX_BUFSIZE  64
	extern char uart0_rx_buf[UART0_RX_BUFSIZE];
	extern char uart0_tx_buf[UART0_TX_BUFSIZE];
	extern unsigned char uart0_rx_head, uart0_rx_tail;
	extern unsigned char uart0_tx_head, uart0_tx_tail;
	extern unsigned char uart0_flags;
#endif // USE_UART0
#endif // UART0_INT_DRIVEN

//***** UART0 *****
#ifdef UART1_INT_DRIVEN
#ifdef USE_UART1
	#define UART1_RX_BUFSIZE  128
	#define UART1_TX_BUFSIZE  128
	extern char uart1_rx_buf[UART1_RX_BUFSIZE];
	extern char uart1_tx_buf[UART1_TX_BUFSIZE];
	extern uint8 uart1_rx_head, uart1_rx_tail;
	extern uint8 uart1_tx_head, uart1_tx_tail;
	extern uint8 uart1_flags;
#endif //USE_UART1
#endif // UART1_INT_DRIVEN

#endif //_SERIAL_CONFIG_H_
